-- For Binding.xml
BINDING_HEADER_GERONIMOHUD = "GeronimoHud";
BINDING_NAME_GERONIMOHUDTOGGLE = "Toggle GeronimoHud";

local GTex = {"Geronimo_HealthHud", "Geronimo_HealthHudBG", "Geronimo_ManaHud","Geronimo_ManaHudBG", "Geronimo_HealthHud_Text", "Geronimo_ManaHud_Text","Geronimo_HealthHud_R", "Geronimo_HealthHudBG_R", "Geronimo_ManaHud_R","Geronimo_ManaHudBG_R", "Geronimo_HealthHud_Text_R", "Geronimo_ManaHud_Text_R", "Geronimo_COMBO_01", "Geronimo_COMBO_02", "Geronimo_COMBO_03", "Geronimo_COMBO_04", "Geronimo_COMBO_05"};

local GERONIMO_SET_X = 70;
local GERONIMO_SET_X_L = 0 - GERONIMO_SET_X;
local GERONIMO_SET_X_R = GERONIMO_SET_X;

GRNMHUD_SHOW_FLAG = 1;
GRNMHUD_PET_FLG = 0;

local function GeronimoSetHeight(self,p,mh,tmh)
	local h = (tmh * p) + (mh - tmh);
	self:SetHeight(h);
	self:SetTexCoord(0, 1, 1- ((tmh * p + (mh - tmh)) / mh), 1);
end
local function GeronimoSetWidth(self,p,mh,tmh)
	local w = (tmh * p) + (mh - tmh);
	self:SetWidth(w);
	self:SetTexCoord(0,((tmh * p + (mh - tmh)) / mh), 0, 1);
end

-----------------------------------------------------------------------------
-- GeronimoHUD_OnLoad()
--
-- OnLoad/Cxgǂݍ݁EL[oChǂݍ
-----------------------------------------------------------------------------
function GeronimoHUD_OnLoad()
	this:RegisterEvent("VARIABLES_LOADED");
	this:RegisterEvent("PLAYER_ENTERING_WORLD");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_REGEN_ENABLED");
	this:RegisterEvent("PLAYER_REGEN_DISABLED");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MAXHEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("PLAYER_COMBO_POINTS");
	this:RegisterEvent("UNIT_PET");
	
	GRNM_HUD_SlashInit();
end
-----------------------------------------------------------------------------
-- INIT_GeronimoHUD()
--
-- 
-----------------------------------------------------------------------------
function INIT_GeronimoHUD()
	local GTexture = {getglobal(GTex[1]), getglobal(GTex[2]), getglobal(GTex[3]), getglobal(GTex[4]), getglobal(GTex[5]), getglobal(GTex[6]), getglobal(GTex[7]), getglobal(GTex[8]), getglobal(GTex[9]), getglobal(GTex[10]), getglobal(GTex[11]), getglobal(GTex[12]), getglobal(GTex[13]), getglobal(GTex[14]), getglobal(GTex[15]), getglobal(GTex[16]), getglobal(GTex[17])};
	local i;
	GTexture[1]:SetAlpha(.2);
	GTexture[1]:SetVertexColor(1,1,0);
	GTexture[2]:SetAlpha(.1);
	GTexture[2]:SetVertexColor(.5,0,0);
	GTexture[3]:SetAlpha(.2);
	GTexture[3]:SetVertexColor(.3, .6, 1);
	GTexture[4]:SetAlpha(.1);
	GTexture[4]:SetVertexColor(.2, .1, .3);
	GTexture[5]:SetAlpha(.6);
--	GTexture[6]:SetText(UnitMana("player"));
	GTexture[6]:SetAlpha(.6);
	GTexture[7]:SetAlpha(.2);
	GTexture[7]:SetVertexColor(1,1,0);
	GeronimoSetHeight(GTexture[7],0,256,256);
	GTexture[8]:SetAlpha(.1);
	GTexture[8]:SetVertexColor(.5,0,0);
	GTexture[9]:SetAlpha(.2);
	GTexture[9]:SetVertexColor(.3, .6, 1);
	GeronimoSetHeight(GTexture[9],0,256,221);
	GTexture[10]:SetAlpha(.1);
	GTexture[10]:SetVertexColor(.2, .1, .3);
	GTexture[11]:SetText("");
	GTexture[11]:SetAlpha(.6);
	GTexture[12]:SetText("");
	GTexture[12]:SetAlpha(.6);
	for i=13,17do
		GTexture[i]:SetAlpha(0);
		GTexture[i]:SetVertexColor(1, .5, .3);
	end
	Geronimo_PetHud:SetVertexColor(0.6,0.8,0);
	Geronimo_PetHud:SetAlpha(.2);
	Geronimo_PetHudBG:SetVertexColor(0.1,0.2,0);
	Geronimo_PetHudBG:SetAlpha(.1);
	Geronimo_PetHud_Text:SetAlpha(.6);

	
end

-----------------------------------------------------------------------------
-- GeronimoHUD_OnEvent()
--
-- OnEvent/C̏
-----------------------------------------------------------------------------
function GeronimoHUD_OnEvent(event,arg1)
	if event=="VARIABLES_LOADED" then
		INIT_GeronimoHUD();
	elseif event=="PLAYER_ENTERING_WORLD" then
		Geronimo_PlayerHealth();
		Geronimo_PlayerMana();
		if not UnitExists("pet") then
			GRNMHUD_PET_FLG = 0;
			GRNMHUD_PET_HIDE();
		else
			GRNMHUD_PET_FLG = 1;
			GRNMHUD_PET_SHOW();
			Geronimo_PetHealth();
		end
 	elseif event=="PLAYER_ENTER_COMBAT" or event=="PLAYER_REGEN_DISABLED" then
		Geronimo_HealthHud:SetAlpha(.6);
		Geronimo_HealthHudBG:SetAlpha(.3);
		Geronimo_ManaHud:SetAlpha(.6);
		Geronimo_ManaHudBG:SetAlpha(.3);
		Geronimo_HealthHud_R:SetAlpha(.6);
		Geronimo_HealthHudBG_R:SetAlpha(.3);
		Geronimo_ManaHud_R:SetAlpha(.6);
		Geronimo_ManaHudBG_R:SetAlpha(.3);
		Geronimo_PetHud:SetAlpha(.5);
		Geronimo_PetHudBG:SetAlpha(.3);
	elseif event=="PLAYER_LEAVE_COMBAT" or event=="PLAYER_REGEN_ENABLED" then
		Geronimo_HealthHud:SetAlpha(.2);
		Geronimo_HealthHudBG:SetAlpha(.1);
		Geronimo_ManaHud:SetAlpha(.2);
		Geronimo_ManaHudBG:SetAlpha(.1);
		Geronimo_HealthHud_R:SetAlpha(.2);
		Geronimo_HealthHudBG_R:SetAlpha(.1);
		Geronimo_ManaHud_R:SetAlpha(.2);
		Geronimo_ManaHudBG_R:SetAlpha(.1);
		Geronimo_PetHud:SetAlpha(.2);
		Geronimo_PetHudBG:SetAlpha(.1);
	elseif event == "UNIT_HEALTH" or event == "UNIT_MAXHEALTH"  then
--		DEFAULT_CHAT_FRAME:AddMessage(event.."_"..arg1)
		if arg1 == "player" then
			Geronimo_PlayerHealth();
		elseif arg1 == "target" then
			Geronimo_TargetHealth();
		elseif arg1 == "pet" then
			Geronimo_PetHealth();
		end
	elseif event == "PLAYER_COMBO_POINTS" then
		getonimo_show_combo();
	elseif event == "PLAYER_TARGET_CHANGED" then
		Geronimo_TargetHealth();
		Geronimo_TargetMana();
	elseif (event == "UNIT_PET") then
		if (arg1 == "player") then
			if not UnitExists("pet") then
				GRNMHUD_PET_HIDE();
			else 
				GRNMHUD_PET_SHOW();
				Geronimo_PetHealth();
			end
			return;
		end
	else
		if arg1 == "player" then
			Geronimo_PlayerMana();
		
		elseif UnitExists("target") then
			Geronimo_TargetMana();
		end
	
	end
end

-----------------------------------------------------------------------------
-- GRNM_HUD_SlashInit()
--
-- Add all Slash Commands
-----------------------------------------------------------------------------
function GRNM_HUD_SlashInit()
  SlashCmdList["GRNM_HUD"] = GRNMHUD_SlashParse;
  SLASH_GRNM_HUD1 = "/grnm";
  SLASH_GRNM_HUD2 = "/ghud";
  SLASH_GRNM_HUD3 = "/grnmhud";
end


-----------------------------------------------------------------------------
-- GRNMHUD_SlashParse()
--
-- Slash Commands
-----------------------------------------------------------------------------
function GRNMHUD_SlashParse()
	
	if GRNMHUD_SHOW_FLAG == 1 then
		GRNMHUD_HIDE();
		GRNMHUD_SHOW_FLAG = 0;
		DEFAULT_CHAT_FRAME:AddMessage("GeronimoHUD:off");
	elseif GRNMHUD_SHOW_FLAG == 0 then
		GRNMHUD_SHOW()
		GRNMHUD_SHOW_FLAG = 1;
		DEFAULT_CHAT_FRAME:AddMessage("GeronimoHUD:on");
	end
end
-----------------------------------------------------------------------------
-- GRNMHUD_SHOW()
--
-- ModS\
-----------------------------------------------------------------------------
function GRNMHUD_SHOW()
	Geronimo_HealthHud:Show();
	Geronimo_HealthHudBG:Show();
	Geronimo_ManaHud:Show();
	Geronimo_ManaHudBG:Show();
	Geronimo_HealthHud_Text:Show();
	Geronimo_ManaHud_Text:Show();
	Geronimo_HealthHud_R:Show();
	Geronimo_HealthHudBG_R:Show();
	Geronimo_ManaHud_R:Show();
	Geronimo_ManaHudBG_R:Show();
	Geronimo_HealthHud_Text_R:Show();
	Geronimo_ManaHud_Text_R:Show();
	Geronimo_COMBO_01:Show();
	Geronimo_COMBO_02:Show();
	Geronimo_COMBO_03:Show();
	Geronimo_COMBO_04:Show();
	Geronimo_COMBO_05:Show();
	if GRNMHUD_PET_FLG == 1 then
		GRNMHUD_PET_SHOW();
	end
end
-----------------------------------------------------------------------------
-- GRNMHUD_HIDE()
--
-- ModS\
-----------------------------------------------------------------------------
function GRNMHUD_HIDE()
	Geronimo_HealthHud:Hide();
	Geronimo_HealthHudBG:Hide();
	Geronimo_ManaHud:Hide();
	Geronimo_ManaHudBG:Hide();
	Geronimo_HealthHud_Text:Hide();
	Geronimo_ManaHud_Text:Hide();
	Geronimo_HealthHud_R:Hide();
	Geronimo_HealthHudBG_R:Hide();
	Geronimo_ManaHud_R:Hide();
	Geronimo_ManaHudBG_R:Hide();
	Geronimo_HealthHud_Text_R:Hide();
	Geronimo_ManaHud_Text_R:Hide();
	Geronimo_COMBO_01:Hide();
	Geronimo_COMBO_02:Hide();
	Geronimo_COMBO_03:Hide();
	Geronimo_COMBO_04:Hide();
	Geronimo_COMBO_05:Hide();
	if GRNMHUD_PET_FLG == 1 then
		GRNMHUD_PET_SHOW();
	end
end
-----------------------------------------------------------------------------
-- GRNMHUD_PET_SHOW()
--
-- ybgo[\
-----------------------------------------------------------------------------
function GRNMHUD_PET_SHOW()
	Geronimo_PetHud:Show();
	Geronimo_PetHudBG:Show();
	Geronimo_PetHud_Text:Show();
end
-----------------------------------------------------------------------------
-- GRNMHUD_PET_HIDE()
--
-- ybgo[\
-----------------------------------------------------------------------------
function GRNMHUD_PET_HIDE()
	Geronimo_PetHud:Hide();
	Geronimo_PetHudBG:Hide();
	Geronimo_PetHud_Text:Hide();
end
-----------------------------------------------------------------------------
-- Geronimo_PlayerHealth()
--
-- vC[wX
-----------------------------------------------------------------------------
function Geronimo_PlayerHealth()
	local pmh = UnitHealthMax("player");
	local pch = UnitHealth("player");
	local p=pch/pmh;
	GeronimoSetHeight(Geronimo_HealthHud,p,256,256);
	Geronimo_HealthHud_Text:SetText(pch.."\n/"..pmh);
end
-----------------------------------------------------------------------------
-- Geronimo_PlayerMana()
--
-- vC[}i
-----------------------------------------------------------------------------
function Geronimo_PlayerMana()
	local um = UnitMana("player");
	local m=UnitMana("player")/UnitManaMax("player");
	GeronimoSetHeight(Geronimo_ManaHud,m,256,221);
	if um == 0 then um = "" end
	Geronimo_ManaHud_Text:SetText(um);
end
-----------------------------------------------------------------------------
-- Geronimo_TargetHealth()
--
-- ^[QbgwX
-----------------------------------------------------------------------------
function Geronimo_TargetHealth()
	local uh = UnitHealth('target');
	if uh == nil then uh=0; end
	local uhm = UnitHealthMax('target');
	local p=uh/uhm;
	local tmh,tch;
	local myTxt;
	GeronimoSetHeight(Geronimo_HealthHud_R,p,256,256);
	if UnitIsDeadOrGhost("target") then
			myTxt = "Dead";
	elseif ((UnitInParty("target") or UnitIsUnit("target","pet"))) then
		myTxt = uh.."\n/"..uhm;
	else
		local mobName = UnitName('target');
		
		
		if mobName == nil then
			myTxt="";
		else
			
			
		
			if MobHealthFrame then
					tch = Geronimo_MobHealth_GetTargetCurHP();
					tmh = Geronimo_MobHealth_GetTargetMaxHP();
				
			else
				tmh = uhm;
				tch = uh;
			end 

			if tch == 0 then
				
				myTxt = "";
			elseif tch==uh and tmh==uhm and uhm<=100 then
				myTxt = uh.."%";
			else
				myTxt = tch.."\n/"..tmh;
			end
			-- message (myTxt);
		end
		
	end
	
	Geronimo_HealthHud_Text_R:SetText(myTxt);
end
-----------------------------------------------------------------------------
-- Geronimo_TargetMana()
--
-- ^[Qbg}i
-----------------------------------------------------------------------------
function Geronimo_TargetMana()
	local tcm=UnitMana("target");
	if tcm == nil then tcm = 0; end
	p=tcm/UnitManaMax("target");
	GeronimoSetHeight(Geronimo_ManaHud_R,p,256,221);
	if tcm == 0 then tcm = nil; end
	Geronimo_ManaHud_Text_R:SetText(tcm);
end
-----------------------------------------------------------------------------
-- Geronimo_PetHealth()
--
-- ybgwX
-----------------------------------------------------------------------------
function Geronimo_PetHealth()
	if UnitIsDeadOrGhost("pet") then
		GeronimoSetWidth(Geronimo_PetHud,0,256,256);
		Geronimo_PetHud_Text:SetText("dead");
	else
		local pmh = UnitHealthMax("pet");
		local pch = UnitHealth("pet");
		local p=pch/pmh;
		GeronimoSetWidth(Geronimo_PetHud,p,256,256);
		Geronimo_PetHud_Text:SetText(pch.."/"..pmh);
	end
end
function getonimo_show_combo()
	local gc = GetComboPoints();
	if gc > 0 then
		Geronimo_COMBO_01:SetAlpha(.8);
	else
		Geronimo_COMBO_01:SetAlpha(0);
	end
	if gc>0 and gc<=1 then
		Geronimo_COMBO_02:SetAlpha(.3);
	elseif gc>1 then
		Geronimo_COMBO_02:SetAlpha(.8);
	else
		Geronimo_COMBO_02:SetAlpha(.0);
	end
	if gc>0 and gc<=2 then
		Geronimo_COMBO_03:SetAlpha(.3);
	elseif gc>2 then
		Geronimo_COMBO_03:SetAlpha(.8);
	else
		Geronimo_COMBO_03:SetAlpha(.0);
	end
	if gc>0 and gc<=3 then
		Geronimo_COMBO_04:SetAlpha(.3);
	elseif gc>3 then
		Geronimo_COMBO_04:SetAlpha(.8);
	else
		Geronimo_COMBO_04:SetAlpha(.0);
	end
	if gc>0 and gc<=4 then
		Geronimo_COMBO_05:SetAlpha(.3);
	elseif gc>4 then
		Geronimo_COMBO_05:SetAlpha(.8);
	else
		Geronimo_COMBO_05:SetAlpha(.0);
	end
end

function  Geronimo_MobHealth_PPP( index )
  if  MobHealth_PPP  then
    return MobHealth_PPP( index );
  else
	if( index and MobHealthDB[index] ) then
		local s, e, pts, pct = string.find(MobHealthDB[index], "^(%d+)/(%d+)$");
		if( pts and pct ) then
			pts = pts + 0;
			pct = pct + 0;
			if( pct ~= 0 ) then
				return pts / pct;
			end
		end
	end
	return 0;
  end
end  -- of My_MobHealth_PPP

function Geronimo_MobHealth_GetTargetCurHP()
  if  MobHealth_GetTargetCurHP  then
	if MobHealth_GetTargetCurHP() then
		return MobHealth_GetTargetCurHP();
	else
		return UnitHealth("target");
	end
  else
    local name  = UnitName("target");
    local level = UnitLevel("target");
    local healthPercent = UnitHealth("target");
    if  name  and  level  and  healthPercent  then
      local index = name..":"..level;
      local ppp = Geronimo_MobHealth_PPP( index );
      return math.floor( healthPercent * ppp + 0.5);
    end
  end
  return 0;
end  -- of My_MobHealth_GetTargetCurHP()

function Geronimo_MobHealth_GetTargetMaxHP()
  if  MobHealth_GetTargetMaxHP  then
	if MobHealth_GetTargetMaxHP() then
		return MobHealth_GetTargetMaxHP();
	else
		return 100;
	end
  else
    local name  = UnitName("target");
    local level = UnitLevel("target");
    if  name  and  level  then
      local index = name..":"..level;
      local ppp = Geronimo_MobHealth_PPP( index );
      return math.floor( 100 * ppp + 0.5);
    end
  end
  return 0;
end  -- of My_MobHealth_GetTargetMaxHP()